﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Scripting.Hosting;
using System.IO;
using IronPython.Hosting;

namespace IronPython_Sample
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            ExtractMethods();
        }

        private void ExtractMethods()
        {
            try
            {
                ScriptEngine engine = Python.CreateEngine();
                // not exactly by the book      
                ScriptScope scope = engine.ExecuteFile("script.py");
                foreach (var item in scope.GetItems().Where(p => p.Value is IronPython.Runtime.PythonFunction))
                {
                    comboBox1.Items.Add(item.Key);
                }
                engine.Runtime.Shutdown();
            }
            catch { }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrWhiteSpace(comboBox1.Text))
            {
                CallPythonMethod(comboBox1.Text);
            }
        }

        private void CallPythonMethod(string methodName)
        {
            //ScriptRuntime runtime = Python.CreateRuntime();
            //dynamic script = runtime.UseFile("script.py");
            //script.HelloWorld();
            try
            {
                ScriptEngine engine = Python.CreateEngine();
                ScriptScope scope = engine.ExecuteFile("script.py");
                var v = engine.Operations.Invoke(scope.GetVariable(methodName));
                textBox1.Text = "Result: ";
                if (v is string)
                    textBox1.Text += v;
                else if (v is int)
                    textBox1.Text += ((int)v).ToString();
                else if (v is IronPython.Runtime.List)
                    ((IronPython.Runtime.List)v).ToList().ForEach(p => textBox1.Text += string.Format("{0}{1}", Environment.NewLine, p.ToString()));
                else if (v is IronPython.Runtime.PythonDictionary)
                {
                    foreach (var item in ((IronPython.Runtime.PythonDictionary)v))
                    {
                        textBox1.Text += string.Format("{2}key: {0}, value {1}", item.Key, item.Value, Environment.NewLine);
                    }
                }
                engine.Runtime.Shutdown();
            }
            catch
            {
                textBox1.Text = string.Format("Error executing: {0}", methodName);
            }
        }
    }
}
